# -*- coding: utf-8 -*-
import urllib2, urllib, xbmcgui, xbmcplugin, xbmc, re, sys, os,dandy, xbmcaddon
from addon.common.addon import Addon

import urlresolver
from md_request import open_url

addon_id='plugin.video.filmemporium_gw'
selfAddon = xbmcaddon.Addon(id=addon_id)
datapath= xbmc.translatePath(selfAddon.getAddonInfo('profile'))
User_Agent = 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/52.0.2743.116 Safari/537.36'
addon = Addon(addon_id, sys.argv)
addon_name = selfAddon.getAddonInfo('name')
ART = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id + '/resources/icons/'))
ICON = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id, 'icon.png'))
FANART = xbmc.translatePath(os.path.join('special://home/addons/' + addon_id , 'fanart.jpg'))
BASEURL = 'http://mythewatchseries.com'
## http://themovieseries.com/


def Main_menu():
    addDir('[B][COLOR deepskyblue]Newest Added/Updated content[/COLOR][/B]',BASEURL + '/new-release?page=1',5,ART + 'latest.jpg',FANART,'')
    addDir('[B][COLOR deepskyblue]Movies[/COLOR][/B]',BASEURL + '/movies?page=1',5,ART + 'allmov.jpg',FANART,'')
    addDir('[B][COLOR deepskyblue]Cinema Movies[/COLOR][/B]',BASEURL + '/cinema-movies?page=1',5,ART + 'cinema.jpg',FANART,'')
    addDir('[B][COLOR deepskyblue]UK Only - Shows and Movies[/COLOR][/B]',BASEURL + '/list?key=&country=12&year=&genre=&quality=all&type=all&sort=&Filter=Filter&page=1',7,ART + 'ukonly.jpg',FANART,'')
    addDir('[B][COLOR deepskyblue]UK Only - Alphabetically[/COLOR][/B]',BASEURL + '/list',11,ART + 'alphauk.jpg',FANART,'')
    addDir('[B][COLOR deepskyblue]US Only - Shows and Movies[/COLOR][/B]',BASEURL + '/list?key=&country=13&year=&page=1',7,ART + 'usonly.jpg',FANART,'')
    addDir('[B][COLOR deepskyblue]US Only - Alphabetically[/COLOR][/B]',BASEURL + '/list',12,ART + 'alphaUS.jpg',FANART,'')
    addDir('[B][COLOR deepskyblue]Shows and Movies [All][/COLOR][/B]',BASEURL + '/list',7,ART + 'allcount.jpg',FANART,'')
    addDir('[B][COLOR deepskyblue]Shows and Movies [All Alpha][/COLOR][/B]',BASEURL + '/list',8,ART + 'alphaall.jpg',FANART,'')
    addDir('[B][COLOR deepskyblue]Full Search[/COLOR][/B]','url',20,ART + 'search.jpg',FANART,'')
    xbmc.executebuiltin('Container.SetViewMode(50)')



def Get_content(url):    
    OPEN = open_url(url).content
    page=url
    referer = url
    headers = {'Host': 'mythewatchseries.com', 'User-Agent': User_Agent, 'Referer': referer}
    Regex = re.compile('<li rel="tooltip".+?<a href="(.+?)">.+?<img src="(.+?)" alt="(.+?)"',re.DOTALL).findall(OPEN)
    for url,icon,name in Regex:
            if '-season-' in url:
                name = name.lstrip()
                addDir('[B][COLOR white]%s[/COLOR][/B]' %name,BASEURL+url,9,icon,FANART,name)    
            else:
                addDir('[B][COLOR white]%s[/COLOR][/B]' %name,BASEURL+url,100,icon,FANART,name)
    curpage=int(page.split('=')[-1])
    nextp=str(curpage+1)
    page=page.replace(str(curpage),nextp)
    page=page.replace('www3','www2')
    addDir('[B][COLOR red]Next Page>>>[/COLOR][/B]',page,5,ART + 'nextpage.jpg',FANART,'')
    xbmc.executebuiltin('Container.SetViewMode(50)')

def Get_episodes(url,name,iconimage):
    OPEN = open_url(url).content
    Regex = re.compile('<div class="bottom">(.+?)</ul>',re.DOTALL).findall(OPEN)
    Regex2 = re.compile('<a href="(.+?)" title="(.+?)"',re.DOTALL).findall(str(Regex))
    Regex2 = list(reversed(Regex2))
    for url,name in Regex2:
        name=name.replace('\\','')
        name = name.replace(description,'').replace(': Episode','Episode').replace(':  Episode','Episode').replace('; Episode','Episode').lstrip()
        addDir('[B][COLOR white]%s[/COLOR][/B]' %name,'https://thewatchseries.us%s'%url,100,iconimage,FANART,'')
    xbmc.executebuiltin('Container.SetViewMode(50)')

def Get_cinema(url):
    OPEN = open_url(url).content
    referer = url
    headers = {'Host': 'mythewatchseries.com', 'User-Agent': User_Agent, 'Referer': referer}
    Regex = re.compile('<span>CINEMA MOVIES</span>(.+?)</ul>',re.DOTALL).findall(OPEN)
    Regex2 = re.compile('<li rel="tooltip".+?<a href="(.+?)">.+?<img src="(.+?)" alt="(.+?)"',re.DOTALL).findall(str(Regex))
    for url,icon,name in Regex2:
        name=name.replace('\\','')
        addDir('[B][COLOR white]%s[/COLOR][/B]' %name,BASEURL+url,100,icon,FANART,'')
    xbmc.executebuiltin('Container.SetViewMode(50)')
    
def Get_alpha(url):
    OPEN = open_url(url).content
    referer = url
    headers = {'Host': 'mythewatchseries.com', 'User-Agent': User_Agent, 'Referer': referer}
    Regex = re.compile('<div class="apha">(.+?)</ul>',re.DOTALL).findall(OPEN)
    Regex2 = re.compile('<a href="(.+?)" rel="(.+?)"',re.DOTALL).findall(str(Regex))
    for url,name in Regex2:
        addDir('[B][COLOR deepskyblue]%s[/COLOR][/B]' %name,BASEURL+url,7,ART + 'alphaall.jpg',FANART,'')
    xbmc.executebuiltin('Container.SetViewMode(50)')

def full_list(url):
    OPEN = open_url(url).content
    referer = url
    headers = {'Host': 'mythewatchseries.com', 'User-Agent': User_Agent, 'Referer': referer}
    Regex = re.compile('<div class="list_movies">(.+?)</ul>',re.DOTALL).findall(OPEN)
    Regex2 = re.compile('<a href="(.+?)".+?>(.+?)</a>.+?<span>(.+?)</span>',re.DOTALL).findall(str(Regex))
    for url,title,year in Regex2:
        name = title + ' [COLOR red](' + year + ')[/COLOR]'
        name=name.replace('\\','')
        geticon = BASEURL + url
        try:
            get_icon = Open_Url(geticon)
            icon = re.compile('<meta itemprop="image" content="(.+?)"').findall(get_icon)[0]
        except:
            icon=ICON
        if '-season-' in url:
            addDir('[B][COLOR white]%s[/COLOR][/B]' %title,BASEURL+url,9,icon,FANART,title)    
        else:
            url = url.replace('/info','')
            url = url + '-episode-0'
            addDir('[B][COLOR white]%s[/COLOR][/B]' %name,BASEURL+url,100,icon,FANART,'')
    np = re.compile("<li class='next'><a href='(.+?)'",re.DOTALL).findall(OPEN)
    for url in np:
        url = '/list' + url
        addDir('[B][COLOR red]Next Page >>>>[/COLOR][/B]',BASEURL+url,7,ART + 'nextpage.jpg',FANART,'')
    xbmc.executebuiltin('Container.SetViewMode(50)')

def alpha_uk(url):
    OPEN = open_url(url).content
    referer = url
    headers = {'Host': 'mythewatchseries.com', 'User-Agent': User_Agent, 'Referer': referer}
    Regex = re.compile('<div class="apha">(.+?)</ul>',re.DOTALL).findall(OPEN)
    Regex2 = re.compile('<a href="(.+?)" rel="(.+?)"',re.DOTALL).findall(str(Regex))
    for url,name in Regex2:
        url = url + '&country=12&year=&sort=&Filter=Filter'
        addDir('[B][COLOR deepskyblue]%s[/COLOR][/B]' %name,BASEURL+url,7,ART + 'alphauk.jpg',FANART,'')
    xbmc.executebuiltin('Container.SetViewMode(50)')

def alpha_US(url):
    OPEN = open_url(url).content
    referer = url
    headers = {'Host': 'mythewatchseries.com', 'User-Agent': User_Agent, 'Referer': referer}
    Regex = re.compile('<div class="apha">(.+?)</ul>',re.DOTALL).findall(OPEN)
    Regex2 = re.compile('<a href="(.+?)" rel="(.+?)"',re.DOTALL).findall(str(Regex))
    for url,name in Regex2:
        url = url + '&country=13&year=&sort=&Filter=Filter'
        addDir('[B][COLOR deepskyblue]%s[/COLOR][/B]' %name,BASEURL+url,7,ART + 'alphaUS.jpg',FANART,'')
    xbmc.executebuiltin('Container.SetViewMode(50)')
    
def Search():
    keyb = xbmc.Keyboard('', 'Search')
    keyb.doModal()
    if (keyb.isConfirmed()):
            search = keyb.getText().replace(' ','%20')
            url = BASEURL + '/search.html?keyword=' + search
            search_res(url)

def search_res(url):
    OPEN = open_url(url).content
    referer = url
    headers = {'Host': 'mythewatchseries.com', 'User-Agent': User_Agent, 'Referer': referer}
    Regex = re.compile('<ul class="listing items">(.+?)</ul>',re.DOTALL).findall(OPEN)
    Regex2 = re.compile('<a href="(.+?)">.+?<img src="(.+?)" alt="(.+?)" />',re.DOTALL).findall(str(Regex))
    for url,icon,name in Regex2:
            if '-season-' in url:
                addDir('[B][COLOR white]%s[/COLOR][/B]' %name,BASEURL+url,9,icon,FANART,name)    
            else:
                url = url.replace('/info','')
                url = url + '-episode-0'
                addDir('[B][COLOR white]%s[/COLOR][/B]' %name,BASEURL+url,100,icon,FANART,'')
    xbmc.executebuiltin('Container.SetViewMode(50)') 


def Get_links(name,url):
    referer = url
    headers = {'Host': 'mythewatchseries.com', 'User-Agent': User_Agent, 'Referer': referer}
    OPEN = open_url(url).content
    match = re.compile('data-video="(.+?)"',re.DOTALL).findall(OPEN)
    for url in match:
        if 'http' not in url:
            url = 'https:' + url
        url = url.replace('/streaming','/embed')
        name2 = url.split('//')[1].replace('www.','')
        name2 = name2.split('/')[0].split('.')[0].upper()
        #if urlresolver.HostedMediaFile(url).valid_url():
        addDir('[B][COLOR white]%s[/COLOR][/B]'%name2,url,100,iconimage,FANART,name)
    xbmc.executebuiltin('Container.SetViewMode(50)')    
########################################try above


def addDir(name,url,mode,iconimage,fanart,description):
	u=sys.argv[0]+"?url="+urllib.quote_plus(url)+"&mode="+str(mode)+"&name="+urllib.quote_plus(name)+"&iconimage="+urllib.quote_plus(iconimage)+"&description="+urllib.quote_plus(description)
	ok=True
	liz=xbmcgui.ListItem(name, iconImage="DefaultFolder.png", thumbnailImage=iconimage)
	liz.setInfo( type="Video", infoLabels={"Title": name,"Plot":description})
	liz.setProperty('fanart_image', fanart)
	if mode==100:
		liz.setProperty("IsPlayable","true")
		ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=False)
	else:
		ok=xbmcplugin.addDirectoryItem(handle=int(sys.argv[1]),url=u,listitem=liz,isFolder=True)
	return ok    

def resolve(name,url,iconimage,description):
    hoster = []
    stream_url = []
    host = ''
    OPEN = open_url(url).content
    match = re.compile('data-video="(.+?)"').findall(OPEN)
    for link in match:
        if  urlresolver.HostedMediaFile(link).valid_url():   #hash out if google return 
            link = link.replace('/openload.co/embed/','/openload.co/f/').replace('/streamango.com/embed/','/streamango.com/f/')         
            label = link.split('//')[1].replace('www.','')
            label = label.split('/')[0].split('.')[0].title()
            label = label.replace('Vidnode','Streamango_x')
            host = '[B][COLOR white]%s[/COLOR][/B]' %label
            hoster.append(host)
            stream_url.append(link)
    if len(match) >1:
            dialog = xbmcgui.Dialog()
            ret = dialog.select('Select Your Host',hoster)
            if ret == -1:
                return
            elif ret > -1:
                    url = stream_url[ret]
    else:
        url = re.compile('data-video="(.+?)"').findall(match)[0]
    try:    
        stream = evaluate(url)
        liz = xbmcgui.ListItem(name, iconImage="DefaultVideo.png", thumbnailImage=iconimage)
        liz.setInfo(type="Video", infoLabels={"Title": name})
        liz.setProperty("IsPlayable","true")
        liz.setPath(stream)
        xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, liz)
    except:pass

# def resolve(name,url,iconimage,description):
        # link = open_url(url).content
        # host = re.compile('<iframe id="embedvideo" src="(.+?)"',re.DOTALL).findall(link)[0]
        # print 'HOST>> ' + host
        # User_Agent = 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/52.0.2743.116 Safari/537.36'
        # headers = {'User-Agent':User_Agent,'Referer':url}
        # final=open_url(host,headers=headers).content
        # stream = re.compile('type:"video/mp4",src:"(.+?)"',re.DOTALL).findall(final)[0]      
        # stream = 'https:' + stream
        # liz = xbmcgui.ListItem(name, iconImage="DefaultVideo.png", thumbnailImage=iconimage)
        # liz.setInfo(type="Video", infoLabels={"Title": description})
        # liz.setProperty("IsPlayable","true")
        # liz.setPath(stream)
        # xbmcplugin.setResolvedUrl(int(sys.argv[1]), True, liz)
        
def evaluate(url):
    if 'mythewatchseries.com' in url:
        url = url.replace('embed.mythewatchseries.com','embed2.mythewatchseries.com')
        link = open_url(url).content
        url = re.compile("<source src='(.+?)'",re.DOTALL).findall(link)[0]
    elif 'thewatchseries.us' in url:
        url = url.replace('embed.thewatchseries.us','embed2.mythewatchseries.com')
        link = open_url(url).content
        url = re.compile("<source src='(.+?)'",re.DOTALL).findall(link)[0]
    elif 'streamango.com' in url:
        link = open_url(url).content
        url = re.compile('type:"video/mp4",src:"(.+?)"',re.DOTALL).findall(link)[0]
        url = 'https:' + url
    elif 'vidnode.net' in url:
        if 'http' not in url:
            url = 'https:' + url
        url = url.replace('/streaming','/embed')
        link = open_url(url).content
        host = re.compile('<iframe id="embedvideo" src="(.+?)"',re.DOTALL).findall(link)[0]
        print 'HOST>> ' + host
        User_Agent = 'Mozilla/5.0 (Windows NT 6.1; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/52.0.2743.116 Safari/537.36'
        headers = {'User-Agent':User_Agent,'Referer':url}
        final=open_url(host,headers=headers).content
        url = re.compile('type:"video/mp4",src:"(.+?)"',re.DOTALL).findall(final)[0]      
        url = 'https:' + url
    elif urlresolver.HostedMediaFile(url):
        url = urlresolver.resolve(url)
        
    else:pass
    
    return url
    
def get_params():
        param=[]
        paramstring=sys.argv[2]
        if len(paramstring)>=2: 
                params=sys.argv[2] 
                cleanedparams=params.replace('?','')
                if (params[len(params)-1]=='/'):
                        params=params[0:len(params)-2]
                pairsofparams=cleanedparams.split('&')
                param={}    
                for i in range(len(pairsofparams)):
                        splitparams={}
                        splitparams=pairsofparams[i].split('=')
                        if (len(splitparams))==2:
                                param[splitparams[0]]=splitparams[1]
                                
        return param
        
params=get_params()
url=None
name=None
iconimage=None
mode=None
fanart=None
description=None


try:
        url=urllib.unquote_plus(params["url"])
except:
        pass
try:
        name=urllib.unquote_plus(params["name"])
except:
        pass
try:
        iconimage=urllib.unquote_plus(params["iconimage"])
except:
        pass
try:        
        mode=int(params["mode"])
except:
        pass
try:        
        fanart=urllib.unquote_plus(params["fanart"])
except:
        pass
try:        
        description=urllib.unquote_plus(params["description"])
except:
        pass
        
        

print "Mode: "+str(mode)
print "URL: "+str(url)
print "Name: "+str(name)
print "IconImage: "+str(iconimage)
#########################################################
	
if mode == None: Main_menu()
elif mode == 5 : Get_content(url)
elif mode == 6: Get_cinema(url)
elif mode == 7 : full_list(url)
elif mode == 8 : Get_alpha(url)
elif mode == 9: Get_episodes(url,name,iconimage)
elif mode == 11 : alpha_uk(url)
elif mode == 12 : alpha_US(url)
elif mode == 10 : Get_links(name,url)
elif mode == 15 : search_res(url)
elif mode == 20 : Search()
elif mode == 100 : resolve(name,url,iconimage,description)
xbmcplugin.endOfDirectory(int(sys.argv[1]))
